#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "curses.h"
#include "struktury.h"
#include "menu.h"
#include "lib.h"

#define DIST 4
int
menu_vyber(char **polozky, int ukazatel, WINDOW * sub_win, int ky, int kx)
{
    int i, maxdelka = 0;
    wint_t klavesa;

    i = 0;
    while (polozky[i])
	maxdelka = fmax(maxdelka, strlen(polozky[i++]));


    wattron(sub_win, COLOR_PAIR(MENU));
    do {
	wclear(sub_win);
	i = 0;
	while (polozky[i]) {
	    if (i == ukazatel)
		wattron(sub_win, A_REVERSE);
	    if (strcmp(polozky[i], "")) {
		mvwprintw8(sub_win, ky + i, kx, L"* %-*s *", maxdelka,
			   polozky[i]);
	    } else
		mvwprintw8(sub_win, ky + i, kx, L"");
	    if (i == ukazatel)
		wattroff(sub_win, A_REVERSE);
	    i++;
	}
	wrefresh(sub_win);

	(void) get_wch(&klavesa);

	switch (klavesa) {
	case L' ':
	case KEY_DOWN:
	    do {
		ukazatel++;
	    }
	    while (polozky[ukazatel] && !strcmp(polozky[ukazatel], ""));
	    if (!polozky[ukazatel])
		ukazatel = 0;
	    break;
	case KEY_UP:
	    do {
		ukazatel--;
	    }
	    while (ukazatel >= 0 && !strcmp(polozky[ukazatel], ""));

	    if (ukazatel < 0)
		do {
		    ukazatel++;
		}
		while (polozky[ukazatel + 1]);
	    break;
	case KEY_BACKSPACE:
	case KEY_LEFT:
	    return -1;
	case KEY_F(10):
	    return -2;
	}
    }
    while (klavesa != L'\n');

    wattroff(sub_win, COLOR_PAIR(MENU));
    return ukazatel;
};



menu_options menu(void)
{
    WINDOW *sub_win;
    char *uzivatel;
    char *polozky[] = { "????", "", "Nový záznam", "Editace záznamu",
	"Tříděné záznamy...", "Statistika ...", "",
	"Konec", NULL
    };
    menu_options navrat_menu[] = { men_esc, men_esc, men_novy, men_editace,
	men_trideni, men_statistika, men_esc, men_konec
    };
    static int ukazatel = 0;
    uzivatel = getenv("USER");

    if (uzivatel)
	polozky[0] = uzivatel;


    sub_win =
	subwin(stdscr, sizeof(polozky) / sizeof(polozky[0]), 35, DIST, 5);
    ukazatel = menu_vyber(polozky, ukazatel, sub_win, 0, 0);

    if (ukazatel == -2)
	return men_konec;

    if (ukazatel != -1)
	switch (navrat_menu[ukazatel]) {
	case men_statistika:
	    delwin(sub_win);
	    return menu_statistika(ukazatel);
	    break;
	case men_trideni:
	    delwin(sub_win);
	    return menu_trideni(ukazatel);
	    break;
	default:
	    delwin(sub_win);
	    return navrat_menu[ukazatel];
	}

    ukazatel = 0;
    delwin(sub_win);
    return men_esc;
}

menu_options menu_statistika(int ukazatel)
{
    WINDOW *sub_win;
    char *polozky[] =
	{ "Průměr", "Kreditů", "Hranice 2.5", "Uděláno předmětů",
	NULL
    };
    menu_options navrat_menu[] = { mens_prumer, mens_kreditu, mens_25,
	mens_udelano
    };
    int navrat;

    sub_win = subwin(stdscr, 5, 35, ukazatel + DIST, 25);

    navrat = menu_vyber(polozky, 0, sub_win, 1, 1);
    delwin(sub_win);

    if (navrat == -2)
	return men_konec;
    if (navrat != -1)
	return navrat_menu[navrat];
    else
	return men_esc;
}

menu_options menu_trideni(int ukazatel)
{
    WINDOW *sub_win;
    char *polozky[] = { "Semestr", "Uděláno v semestru",
	"Známka", NULL
    };
    menu_options navrat_menu[] =
	{ ment_semestr, ment_vsemestru, ment_znamka };
    int navrat;

    sub_win = subwin(stdscr, 6, 35, ukazatel + DIST, 25);

    navrat = menu_vyber(polozky, 0, sub_win, 1, 1);
    delwin(sub_win);

    if (navrat == -2)
	return men_konec;
    if (navrat != -1)
	return navrat_menu[navrat];
    else
	return men_esc;
}
